<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2008 Mathieu Virbel <mathieu.v@capensis.fr>               |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/

$guest_account = true;

chdir('../..');
include("./include/auth.php");

global $realtime_refresh, $realtime_window;

/* ================= input validation ================= */
input_validate_input_number(get_request_var("ds_step"));
input_validate_input_number(get_request_var("graph_timespan"));
/* ==================================================== */

load_current_session_value("ds_step",        "sess_realtime_ds_step", read_config_option("realtime_interval"));
load_current_session_value("graph_timespan", "sess_realtime_graph_timespan", read_config_option("realtime_gwindow"));

if (!is_dir(read_config_option("realtime_cache_path"))) {
	print "<html>\n";
	print "<body>\n";
	print "	<p><strong>The Image Cache Directory directory does not exist.  Please first create it and set permissions and then attempt to open another realtime graph.</strong></p>\n";
	print "</body>\n";
	print "</html>\n";
	exit;
}else{
	if (!is_writable(read_config_option("realtime_cache_path"))) {
		print "<html>\n";
		print "<body>\n";
		print "	<p><strong>The Image Cache Directory is not writable.  Please set permissions and then attempt to open another realtime graph.</strong></p>\n";
		print "</body>\n";
		print "</html>\n";
		exit;
	}
}

?>
<html>
<head>
	<title>Cacti - Realtime</title>
	<meta http-equiv=refresh content='<?php echo $_REQUEST['ds_step']; ?>'>
	<link href="../../include/main.css" rel="stylesheet">
	<script type="text/javascript">
	<!--
	var ds_step = <?php echo $_REQUEST['ds_step']; ?> + 1;
	function countdown_update() {
		ds_step--;
		if (ds_step < 0) {
			ds_step = 0;
		}

		var el = document.getElementById('countdown');

		if (el) {
			el.innerHTML = '' + ds_step + ' seconds left.';
		}

		/* set the window size */
		height = document.getElementById("realtime").clientHeight;
		width  = document.getElementById("realtime").clientWidth;

		if (height > 100) {
			window.resizeTo(width+40, height+140);
		}

		setTimeout('countdown_update()', 1000);
	}
	setTimeout('countdown_update()', 1000);
	-->
	</script>
</head>
<body style="text-align: center;">
<form method="get" action="graph_popup_rt.php" id="gform">
	<input type="hidden" name="local_graph_id" value="<?php echo $_REQUEST['local_graph_id']; ?>"/>
	<label for="graph_timespan">Timespan</label>
	<select name="graph_timespan" id="graph_timespan" onchange="document.getElementById('gform').submit()">
	<?php
	foreach ($realtime_window as $interval => $text) {
		printf('<option value="%d"%s>%s</option>',
			$interval, $interval == $_REQUEST['graph_timespan'] ? ' selected="selected"' : '', $text
		);
	}
	?>
	</select>
	<label for="ds_step">Interval</label>
	<select name="ds_step" id="ds_step" onchange="document.getElementById('gform').submit()">
	<?php
	foreach ($realtime_refresh as $interval => $text) {
		printf('<option value="%d"%s>%s</option>',
			$interval, $interval == $_REQUEST['ds_step'] ? ' selected="selected"' : '', $text
		);
	}
	?>
	</select>
	- <span id="countdown"><?php echo $_REQUEST['ds_step']; ?> seconds left.</span>
</form>
<img id='realtime' src="<?php print $config['url_path'] . '/plugins/realtime/graph_image_rt.php?graph_start=-' . $_REQUEST['graph_timespan'] . '&graph_end=0&local_graph_id=' . $_REQUEST['local_graph_id'] . '&ds_step=' . $_REQUEST['ds_step']; ?>"/>
</body>
</html>
